package net.t2code.t2codelib.SPIGOT.system.config.config;

import lombok.Getter;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import net.t2code.t2codelib.SPIGOT.system.T2CodeLibMain;
import net.t2code.t2codelib.Util;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class SelectLibConfig {

    @Getter
    private static Boolean updateCheckOnJoin;
    @Getter
    private static Boolean t2cTestDevelopment = false;
    @Getter
    private static Integer updateCheckTimeInterval;
    @Getter
    private static Boolean seePreReleaseUpdates;
    @Getter
    private static Boolean updateCheckFullDisable;
    @Getter
    private static Boolean debug;
    @Getter
    private static String language;
    @Getter
    private static Boolean developerTool;
    @Getter
    private static Boolean bungee;
    @Getter
    private static Boolean inventoriesCloseByServerStop;
    @Getter
    private static String commandPermToggleCommand;

    public static void onSelect() {
        File config = new File(T2CodeLibMain.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        if (yamlConfiguration.contains("t2cTestDevelopment")) {
            t2cTestDevelopment = yamlConfiguration.getBoolean("t2cTestDevelopment");
        }

        updateCheckOnJoin = yamlConfiguration.getBoolean("Plugin.UpdateCheck.OnJoin");
        updateCheckTimeInterval = yamlConfiguration.getInt("Plugin.UpdateCheck.TimeInterval");
        seePreReleaseUpdates = yamlConfiguration.getBoolean("Plugin.UpdateCheck.SeePreReleaseUpdates");
        updateCheckFullDisable = yamlConfiguration.getBoolean("Plugin.UpdateCheck.AllPlugins.FullDisable");
        debug = yamlConfiguration.getBoolean("Plugin.Debug");
        language = yamlConfiguration.getString("Plugin.language");
        developerTool = yamlConfiguration.getBoolean("Plugin.Not recommended to disable.developerTool");
        bungee = yamlConfiguration.getBoolean("BungeeCord.Enable");
        inventoriesCloseByServerStop = yamlConfiguration.getBoolean("Player.Inventories.CloseByServerStop");
        commandPermToggleCommand = yamlConfiguration.getString("Command.PermToggle.PermissionSetCommand");
    }

    public static void configCreate() {
        long long_ = System.currentTimeMillis();
        if (new File(T2CodeLibMain.getPath(), "config.yml").exists()){
            if (T2CodeLibMain.getPlugin().getConfig().getBoolean("Plugin.Debug")) T2Csend.console(Util.getPrefix() + " §5DEBUG: §6" +  " §4config.yml are created / updated...");
        } else T2Csend.console(Util.getPrefix() + " §4config.yml are created...");


        File config = new File(T2CodeLibMain.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);


        T2Cconfig.set("Plugin.UpdateCheck.OnJoin", true, yamlConfiguration);
        T2Cconfig.set("Plugin.UpdateCheck.TimeInterval", 60, yamlConfiguration);
        T2Cconfig.set("Plugin.UpdateCheck.SeePreReleaseUpdates", true, yamlConfiguration);
        T2Cconfig.set("Plugin.UpdateCheck.AllPlugins.FullDisable", false, yamlConfiguration);
        T2Cconfig.set("Plugin.language", "english", yamlConfiguration);
        T2Cconfig.set("Plugin.Not recommended to disable.developerTool", true, yamlConfiguration);

        T2Cconfig.set("BungeeCord.Enable", T2CodeLibMain.getIsBungee(), yamlConfiguration);
        T2Cconfig.set("Player.Inventories.CloseByServerStop", true, yamlConfiguration);

        T2Cconfig.set("Command.PermToggle.PermissionSetCommand","lp user [player] permission set [perm] [value]",yamlConfiguration);

        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }

        T2Csend.console(Util.getPrefix() + " §2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }
}
